<template>
  <div class="dropdown" v-if="options">

    <div role="group" class="form-group form-row">
      <label for="uid-eu0bex2k8bo" class="col-form-label col-sm-3"> {{label}} </label>
      <div class="col-sm-9">
        <!-- Dropdown Input -->
        <input class="form-control"
               :name="name"
               autocomplete="off"
               @focus="showOptions()"
               @blur="exit()"
               @keyup="keyMonitor"
                v-model="searchFilter"
               :disabled="disabled"
               :placeholder="placeholder" />

        <!-- Dropdown Menu -->
        <div class="dropdown-wrapper-init">
          <div class="dropdown-content" v-show="optionsShown">
            <div class="dropdown-wrapper">
              <div
                  class="dropdown-item"
                  @mousedown="selectOption(option)"
                  v-for="(option, index) in filteredOptions"
                  :key="index">
                {{ option.name || option.id || '-' }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  export default {
    name: 'Dropdown',
    template: 'Dropdown',
    props: {
      name: {
        type: String,
        required: false,
        default: 'dropdown',
        note: 'Input name'
      },
      label: {
        type: String,
        required: false,
        default: '',
        note: 'Label'
      },
      options: {
        type: Array,
        required: true,
        default: [],
        note: 'Options of dropdown. An array of options with id and name',
      },
      placeholder: {
        type: String,
        required: false,
        default: 'Please select an option',
        note: 'Placeholder of dropdown'
      },
      disabled: {
        type: Boolean,
        required: false,
        default: false,
        note: 'Disable the dropdown'
      },
      maxItem: {
        type: Number,
        required: false,
        default: 6,
        note: 'Max items showing'
      },
      value: Object
    },
    data() {
      return {
        selected: {},
        optionsShown: false,
        searchFilter: ''
      }
    },
    created() {
      this.$emit('selected', this.selected);
    },
    computed: {
      filteredOptions() {
        if (this.searchFilter.length < 1 && !this.optionsShown && this.value && this.value.name && this.value.id) {
          this.selectOption(this.value);
        }
        const filtered = [];
        const regOption = new RegExp(this.searchFilter, 'ig');
        for (const option of this.options) {
          if (this.searchFilter.length < 1 || option.name.match(regOption)){
            if (filtered.length < this.maxItem) filtered.push(option);
          }
        }
        return filtered;
      }
    },
    methods: {
      selectOption(option) {
        this.selected = option;
        this.optionsShown = false;
        this.searchFilter = this.selected.name;
        this.$emit('selected', this.selected);
      },
      showOptions(){
        if (!this.disabled) {
          this.searchFilter = '';
          this.optionsShown = true;
        }
      },
      exit() {
        if (!this.selected.id) {
          this.selected = {};
          this.searchFilter = '';
        } else {
          this.searchFilter = this.selected.name;
        }
        this.$emit('selected', this.selected);
        this.optionsShown = false;
      },
      // Selecting when pressing Enter
      keyMonitor: function(event) {
        if (event.key === "Enter" && this.filteredOptions[0])
          this.selectOption(this.filteredOptions[0]);
      }
    },
    watch: {
      searchFilter() {
        if (this.filteredOptions.length === 0) {
          this.selected = {};
        }
        this.$emit('filter', this.searchFilter);
      }
    }
  };
</script>


<style lang="scss" scoped>
  .dropdown {
    position: relative;
    display: block;
    margin: auto;
    .dropdown-wrapper-init {
      width: 100%;
      position: inherit;
    }
    .dropdown-wrapper {
      width: 100%;
    }
    .dropdown-input {
      background: #fff;
      cursor: pointer;
      border: 1px solid #e7ecf5;
      border-radius: 3px;
      color: #333;
      display: block;
      font-size: .8em;
      padding: 6px;
      min-width: 250px;
      max-width: 250px;
      &:hover {
        background: #f8f8fa;
      }
    }
    .dropdown-content {
      position: absolute;
      background-color: #fff;
      max-width: initial;
      max-height: 248px;
      width: 100%;
      border: 1px solid #e7ecf5;
      box-shadow: 0px -8px 34px 0px rgba(0,0,0,0.05);
      overflow: auto;
      z-index: 100;
      .dropdown-item {
        color: black;
        font-size: inherit;
        line-height: 1em;
        padding: 10px;
        text-decoration: none;
        display: block;
        cursor: pointer;
        &:hover {
          background-color: #e7ecf5;
        }
      }
    }
    .dropdown:hover .dropdowncontent {
      display: block;
    }
  }
</style>
